﻿
Enumeration
  #Window
  
  #GadgetKartinka
  #SamaKartinka
  
  #File
  
  #Canvas
  #Canvas2
  #Vstavka
  #VstavkinaKartinka
EndEnumeration

Global *MemoryID ; указатель для памяти, в котором будет сидеть файл 01.bin

; массив с кодами цветов
Global Dim SegaSegmentColor.a(16)
; 0, 36, 72, 109, 145, 181, 219, 255
SegaSegmentColor(2)  =  36
SegaSegmentColor(4)  =  72
SegaSegmentColor(6)  = 109
SegaSegmentColor(8)  = 145
SegaSegmentColor(10) = 181
SegaSegmentColor(12) = 219
SegaSegmentColor(14) = 255

; создаем сложный массив с 4 колонками и 16 строчек в каждой. как Ексель таблица.
Structure colorstructure
  ; 17 а не 16 - потому что считается количество ячеек с 0. но мне для удобства хотелось бы с 1 считать.
  ; поэтому 17
  ColorNum.l[17] 
EndStructure
Global Dim PalNum.colorstructure(4)


; процедура для рисования тайла
Procedure RisuemTile(startx.u, starty.u, memory.l)
  
  ; счетчик сдвига в памяти
  k = 0
  
  ; расчет докуда крутить по Х и по У
  endx = startx + 7
  endy = starty + 7 
  
  ; сами циклы
  For y = starty To endy
    For x = startx To endx Step 2 ; перепрыгивать каждые 2
        
        ; читаем значение из памяти
        Number = PeekA(memory + k)
        
        ; раскладываем число на 2 пикселя. по 4 бита на пиксель
        first  = Number >> 4 ; знакомый сдвиг
        second = Number & $F ; новая херня - отсечение по маске.
        ; рисуем точки с нужными цветами
        Plot(x,     y, PalNum(2)\ColorNum[first  + 1]) ; надо было цвет втулить начиная с 0
        Plot(x + 1, y, PalNum(2)\ColorNum[second + 1]) ; теперь приходится + 1 добавлять
        
        ; сдвиг по памяти дальше
        k + 1
        
    Next
  Next  
  
EndProcedure


; читаем файл с палитрами.
If ReadFile(#File, "pal.bin")
  
  ; первая палитра
  pal = 1
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; вторая палитра
  pal = 2
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; третья палитра
  pal = 3
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; четвертая палитра
  pal = 4
  For colornumindex = 1 To 16
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  CloseFile(#File)
EndIf

; создаем само изображение, пока пустое. это будет черный длинный прямоугольник
CreateImage(#SamaKartinka, 320, 80)

; стартуем сам процесс рисования
; ставим вывод, что рисовать в картинку
If StartDrawing(ImageOutput(#SamaKartinka))
    
  ; сначала черный фон на всю картинку
  Box(0, 0, 320, 80, RGB(0, 0, 0)) ; это черный цвет. в принципе можно было просто 0 написать вместо RGB(0, 0, 0)
  
  y = 0 ; первая палитра начнет рисоваться с самого верха 
  ; стартанем цикл в цикле с перебором всех ячеек в нашем массиве палитр
  For Pal = 1 To 4
    ; гоняем все 4 палитры
    
    ; на входе в цвета сбрасываем координату Х на начало картинки
    x = 0
    For ColorNumIndex = 1 To 16
      ; гоняем все цвета в конкретной палитре
      
      Box(x, y, 20, 20, PalNum(Pal)\ColorNum[ColorNumIndex])
      
      ; сдвигаем координату вправо для следующего цвета
      x + 20 
    Next
    ; когда достигли последнего 16 цвета в палитре - сдвигаем координату на одну строчку ниже
    y + 20
  Next
  
  ; остановка рисования
  StopDrawing()
EndIf

; прочитаем в память файл иконки
If ReadFile(#File, "01.bin")
  
  ; получаем размер файла
  length = Lof(#File)
  
  ; резервируем память нужного размера под файл
  *MemoryID = AllocateMemory(length)         ; allocate the needed memory
  
  If *MemoryID
    ; если память зарезервировалась
    
    ; читаем из файла в эту память
    ReadData(#File, *MemoryID, length)   ; read all data into the memory block
    
  Else
    ; а могла память и не зарезервироваться. мало ли какой глюк.
    MessageRequester("ошибка", "во время работы с памятью возникли проблемы.")
  EndIf  
  
  ; закрываем файл
  CloseFile(#File)
EndIf

; главное окно программы
If OpenWindow(#Window, 100, 100, 340, 160, "Якубович под грибами играет в Сегу", #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  
  ; добавляем гаджет-картинку, с подготовленным изображением
  ImageGadget(#GadgetKartinka, 10, 10, 320, 80, ImageID(#SamaKartinka))
  
  ; добавлем гаджет-канвас, куда будем рисовать графику из файла 01.bin
  CanvasGadget(#Canvas, 110, 110, 32, 32)  
  
  ; стартуем рисование картинки на гаджете-канвасе
  If StartDrawing(CanvasOutput(#Canvas))
    
    ; рисуем первый тайл в 0:0 координатах
    RisuemTile(0,  0, *MemoryID)
    
    ; рисуем второй тайл. он получается 0:8 и считаем память для следующего тайла то есть + 32 байта.
    RisuemTile(0,  8, *MemoryID + 32)
    
    ; третий тайл, и так далее
    RisuemTile(0, 16, *MemoryID + 64)
    RisuemTile(0, 24, *MemoryID + 96)
    
    RisuemTile(8,  0, *MemoryID + 128)
    RisuemTile(8,  8, *MemoryID + 160)
    RisuemTile(8, 16, *MemoryID + 192)
    RisuemTile(8, 24, *MemoryID + 224)
    
    RisuemTile(16,  0, *MemoryID + 256)
    RisuemTile(16,  8, *MemoryID + 288)
    RisuemTile(16, 16, *MemoryID + 320)
    RisuemTile(16, 24, *MemoryID + 352)
    
    RisuemTile(24,  0, *MemoryID + 384)
    RisuemTile(24,  8, *MemoryID + 416)
    RisuemTile(24, 16, *MemoryID + 448)
    RisuemTile(24, 24, *MemoryID + 480)
    
    ; остановка рисования
    StopDrawing()
  EndIf
  
  ; канвас для рисования картинки для вставки
  CanvasGadget(#Canvas2, 190, 110, 32, 32) 
  ; кнопка для вставки
  ButtonGadget(#Vstavka, 230, 110, 80, 20, "вставить")
  
  
  ; бесконечный цикл обработки событий на окне
  Repeat
    
    ; разбор где именно происходит событие
    Select WaitWindowEvent()

      Case #PB_Event_Gadget
        ; это было событие на каком-то гаджете
        
        ; проверяем какой именно гаджет это был
        Select EventGadget()
            
          Case #Vstavka
            ; ага! это была кнопка!
            
            If EventType() = #PB_EventType_LeftClick
              ; если событие на кнопке это левый клик мышкой, то...
              
              ; сначала освобождаем, но только в случае если картинка существует.
              If IsImage(#VstavkinaKartinka)                
                FreeImage(#VstavkinaKartinka)                
              EndIf
              
              ; проверка - сидит ли в буфере обмена картинка?
              If GetClipboardImage(#VstavkinaKartinka)
                ; да, все в порядке и картинка там есть
                
                ; проверить на размеры
                If ImageWidth(#VstavkinaKartinka) = 32 And ImageHeight(#VstavkinaKartinka) = 32
                  ; все в порядке и размеры совпадают 32х32
                  
                  ; выставляем в канвас вставки наше изображение
                  SetGadgetAttribute(#Canvas2, #PB_Canvas_Image, ImageID(#VstavkinaKartinka))
                  
                Else
                  ; размеры несовпадают
                  MessageRequester("ашипка", "в буфере обмена изображение хоть и есть, но не соответствует размеру 32х32 пикселя.")
                EndIf

              Else
                ; нет. в буфере может быть текст или он пустой или еще чего... но не картинка.
                MessageRequester("ашипка", "в буфере обмена нет изображения для вставки.")
              EndIf
              
            EndIf

        EndSelect

      Case #PB_Event_CloseWindow
        ; событие закрытия окна
        qiut = 1
   
    EndSelect
    
  ; крутить бесконечно, пока переменная qiut не будет равна 1. то есть пока не будет нажат крестик на окне.
  Until qiut = 1

EndIf

End


Enumeration
  #Window
EndEnumeration


If OpenWindow(#Window, 100, 100, 200, 160, "", #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  
  Repeat
    Select WaitWindowEvent()

      Case #PB_Event_Gadget

        Select EventGadget()
           
          Case 0
            If EventType() = #PB_EventType_LeftClick
            EndIf

        EndSelect

      Case #PB_Event_CloseWindow
        qiut = 1
   
    EndSelect
  Until qiut = 1

EndIf

End
; IDE Options = PureBasic 6.00 LTS (Windows - x86)
; CursorPosition = 275
; FirstLine = 258
; Folding = -
; EnableXP
; DPIAware